org $500

def VIA1	$1800
def VIA2	$1c00

def ORB		%0000
def ORA		%0001
def DDRB	%0010
def DDRA	%0011
def ACR		%1011
def IER		%1110

def DUMBMEM	10		;dump address to store intermediate results

;serial com. is on VIA1
;data in is pb0:   00000001 reversed
;data out is pb1:  00000010 reversed
;clock in is pb2:  00000100 reversed
;clock out is pb3: 00001000 reversed
;atn in is pb7:    10000000 (and ca1) reversed

	sei
	lda	#127		;disable all interrupts in the VIAs
	sta	VIA1+IER
	sta	VIA2+IER
	lda	VIA1+ACR	;disable Latch for reg B
	and	#%11111101
	sta	VIA1+ACR
	lda	VIA1+DDRB	;ensure direction of IO
	ora	#%00001010
	and	#%01111010
	sta	VIA1+DDRB
	lda	#%10000		;clear output and setup input
	sta	VIA1+ORB
	lda	VIA2+DDRB	;ensure led line is output
	ora	#%1000
	sta	VIA2+DDRB
nc:	jsr	receivebyte
	jsr	do_instruction
	jmp	nc

;;no check on the range of A, don't fuck it up
;do_instruction:
;	clc			;a jump table with self-modifying code
;	rol			;mul A by 4
;	rol
;	sta	di_+1		;store the relative jump offset
;di_:	bcc	.		;and do the jump
;	jsr	ledon		;inst 0
;	rts
;	jsr	ledoff		;inst 1
;	rts
;	jsr	readmem		;inst 2
;	rts
;	jsr	writemem	;inst 3
;	rts

do_instruction:
	clc			;a jump table with self-modifying code
	rol			;mul A by 2
	sta	di_+1		;store the relative jump offset
di_:	bcc	.		;and do the jump
	bcc	ledon
	bcc	ledoff
	bcc	readmem
	bcc	writemem

;guess what this function does...
ledon:
	lda	VIA2+ORB
	ora	#%1000
	sta	VIA2+ORB
	rts

;guess what this function does...
ledoff:
	lda	VIA2+ORB
	and	#%11110111
	sta	VIA2+ORB
	rts

;reads the address (low|high), then sends the byte back to the c64
readmem:
	jsr	receivebyte	;self-modifying code to store the address
	sta	rm_+1		;for the lda
	jsr	receivebyte
	sta	rm_+2
rm_:	lda	$ffff		;$ffff is a dummy address, it is set
	jsr	sendbyte	;to the wanted address by code above
	rts

;reads the address (low|high), then the data byte and stores it
writemem:
rts
.byte 0, 0
	;jsr	receivebyte	;self-modifying code for the address
	sta	wm_+1
	jsr	receivebyte
	sta	wm_+2
	jsr	receivebyte
wm_:	sta	$ffff		;$ffff is a dumb address, set by code above
	rts

;returns the byte in A, waits forever, no timeout!
;smokes X, Y, flags
recv: .byte 0
receivebyte:
	ldx	#8
	ldy	#%1000
rb0:	lda	VIA1+ORB	;wait for atn in
rb_:	bpl	rb0
	sty	VIA1+ORB	;send ack
	ror			;store bit
	lda	recv		;(we send first high bits then low bits,
	rol			;thus the use of rol)
	sta	recv
	lda	rb_		;self-modifying code: bpl/bmi switch
	eor	#%100000	;bpl is $10, bmi is $30
	sta	rb_
	tya
	eor	#%11000
	tay
	dex
	bne	rb0
	lda	recv
	rts

sendbyte:
	ldx	#8
sb0:	rol
	bcs	sb1
	ldy	#%0000
	sty	VIA1+ORB
	ldy	#%1000
	sty	VIA1+ORB
	bcc	sb2
sb1:	ldy	#%0010
	sty	VIA1+ORB
	ldy	#%1010
	sty	VIA1+ORB
sb2:	ldy	VIA1+ORB	;wait for ack
	bpl	sb2
	rol
	bcs	sb3
	ldy	#%11000
	sty	VIA1+ORB
	ldy	#%10000
	sty	VIA1+ORB
	bcc	sb4
sb3:	ldy	#%11010
	sty	VIA1+ORB
	ldy	#%10010
	sty	VIA1+ORB
sb4:	ldy	VIA1+ORB	;wait for ack
	bmi	sb4
	dex
	bne	sb0
	ldy	#%10000		;clear output reg
	sty	VIA1+ORB
	rts
