org $500

def VIA1	$1800
def VIA2	$1c00

def ORB		%0000
def ORA		%0001
def DDRB	%0010
def DDRA	%0011
def ACR		%1011
def IER		%1110

def DUMBMEM	10		;dump address to store intermediate results

;serial com. is on VIA1
;data in is pb0:   00000001 reversed
;data out is pb1:  00000010 reversed
;clock in is pb2:  00000100 reversed
;clock out is pb3: 00001000 reversed
;atn in is pb7:    10000000 (and ca1) reversed

	sei
	lda	#127		;disable all interrupts in the VIAs
	sta	VIA1+IER
	sta	VIA2+IER
	lda	VIA1+ACR	;disable Latch for reg B
	and	#%11111101
	sta	VIA1+ACR
	lda	VIA1+DDRB	;ensure direction of IO
	ora	#%00001010
	and	#%01111010
	sta	VIA1+DDRB
	lda	#%10000		;clear output
	sta	VIA1+ORB
	lda	VIA2+DDRB	;ensure led line is output
	ora	#%1000
	sta	VIA2+DDRB
w0:	ldy	#%1000
w1:	lda	VIA1+ORB	;wait for a command from the C64
	and	#%10000000
	beq	w1
	lda	VIA1+ORB	;get input bit 0
	sty	VIA1+ORB	;send ack
	and	#%00000001
	sta	DUMBMEM
	ldy	#%10000
w2:	lda	VIA1+ORB	;wait for bit 1 of the command
	and	#%10000000
	bne	w2
	lda	VIA1+ORB
	sty	VIA1+ORB	;send ack
	and	#%00000001
	asl
	ora	DUMBMEM		;only 0 or 1 as commands for now
	beq	setled
	lda	VIA2+ORB	;unset led
	and	#%11110111
	sta	VIA2+ORB
	jmp	w0
setled:	lda	VIA2+ORB	;set led
	ora	#%1000
	sta	VIA2+ORB
	jmp	w0
