;keys: (output line, input read)
;1 = %0111 1111, %1111 1110
;2 = %0111 1111, %1111 0111

org $c000

def cia1	$dc00
def cia2	$dd00
def row		0
def col		1
def cra		14
def crb		15
def icr		%1101
def ddra	2
def ddrb	3
def pra		0
def prb		1

	sei
	lda	#<dumbint	;replace NMI with dumbint
	sta	$fffa
	lda	#>dumbint
	sta	$fffb
	lda	#127		;disable interrupts from CIAs
	sta	cia1+icr
	sta	cia2+icr
	lda	cia1+cra	;stop timers, first CIA
	and	#$fe
	sta	cia1+cra
	lda	cia1+crb
	and	#$fe
	sta	cia1+crb
	lda	cia2+cra	;second CIA
	and	#$fe
	sta	cia2+cra
	lda	cia2+crb
	and	#$fe
	sta	cia2+crb
	lda	#$ff		;force CIA1 into keyboard mode
	sta	cia1+ddra	;and CIA2 for serial comm. over port
	lda	#0
	sta	cia1+ddrb
	sta	cia2+ddrb
	lda	#$3f
	sta	cia2+ddra
	lda	1		;remove ROMs and keep IO lines
	ora	#%00000101
	and	#%11111101
	sta	1
	lda	#%01111111	;select keyboard line
	sta	cia1+row
k1:	lda	cia1+col	;read keyboard
	cmp	cia1+col
	bne	k1
	cmp	#%11111110
	beq	ledon
	cmp	#%11110111
	bne	k1

;on the port, pins:
; 5 - data
; 4 - clock
; 3 - atn
;serial com. on cia2, port A
;data in:   10000000
;clock in:  01000000
;data out:  00100000
;clock out: 00010000
;atn out:   00001000
;2 lower bits of cia2 should always be 1
;ledoff: send the LEDOFF command to the floppy
ledoff:	lda	#%00100011	;send command %01 to the floppy
	sta	cia2+pra	;send first bit (1), so negate as 0
	eor	#%00001000
	sta	cia2+pra
	tax
t1:	lda	cia2+pra	;wait for clock in to be 1
	and	#%01000000
	bne	t1
	txa
	and	#%11011111	;send second bit (0), so negate as 1
	sta	cia2+pra
	eor	#%00001000
	sta	cia2+pra
t2:	lda	cia2+pra	;wait for clock in to be 0
	and	#%01000000
	beq	t2
	jmp	k1		;done

;ledon: send the LEDON command to the floppy
ledon:	lda	#%00000011	;send command %00 to the floppy
	sta	cia2+pra
	eor	#%00001000
	sta	cia2+pra	;send first bit (0)
	tax
o1:	lda	cia2+pra	;wait for clock in to be 1
	and	#%01000000
	bne	o1
	txa			;send second bit (0)
	and	#%11011111
	sta	cia2+pra
	eor	#%00001000
	sta	cia2+pra
o2:	lda	cia2+pra	;wait for clock in to be 0
	and	#%01000000
	beq	o2
	jmp	k1		;done

dumbint:rti
