org $c000

def cia1	$dc00
def cia1_row	cia1
def cia1_col	cia1+1
def cia1_cra	cia1+14
def cia1_crb	cia1+15

	sei
	;stop interrupts from CIA 1
	lda	cia1_cra
	and	#$fe
	sta	cia1_cra
	lda	cia1_crb
	and	#$fe
	sta	cia1_crb

	;take away ROMs but keep I/O lines
	;so 101 for CHAREN|HIRAM|LORAM
	lda	$01
	ora	#%00000101	;we want I/O stuff mapped
	and	#%11111101	;loram/hiram set to 0 to remove ROMs
	sta	$01

	;put our own IRQ handlers (that will do nothing)

	;display keyboard status forever
start:	lda	#8
	sta	loop
	lda	#0
	sta	line
	lda	#1024/256
	sta	line+1
	ldx	#$fe
	stx	cur_row
more:	stx	cia1_row
wait:	lda	cia1_col	;the ROM does it this way: lda/cmp/bne
	cmp	cia1_col	;don't ask me why...
	bne	wait
	pha
	txa
	jsr	printbin	;print the row "number" (in fact bit at 0)
	inc	column
	pla
	jsr	printbin	;print the row's value
	lda	line		;next line
	clc
	adc	#40
	sta	line
	bcc	ni
	inc	line+1
ni:	lda	#0		;column 0
	sta	column
	lda	cur_row		;next row of keyboard
	sec			;we want a 1 for the rol
	rol
	tax			;put the row back in x
	sta	cur_row
	dec	loop
	bne	more
	jmp	start

printbin:
	;print A as binary
	ldx	#8
	ldy	column
pm:	rol
	pha
	lda	#49
	bcs	ap
	lda	#48
ap:	;sta	line,y, except line changes programatically
	.byte $99
line:	.word 1024	;yeah, data in code
	iny
	pla
	dex
	bne	pm
	sty	column
	rts

;end of code
;data
data:
def column data+1
def loop data+2
def cur_row data+3
